import sys
argv=sys.argv
try:
    contig_file=argv[1]
    bridge_file=argv[2]
    now_count=argv[3]
except:
    contig_file="Connected_Result_3.fa"
    bridge_file="keep_clr_3.txt"
    now_count="3"
c_nt=dict()
c_nt['A']='T';c_nt['T']='A';c_nt['C']='G';c_nt['G']='C'
def complement(seq):
    global c_nt
    s_list=list(seq)
    s_list.reverse()
    new_s_list=[]
    for i in range(len(s_list)):
        now_nt=s_list[i]
        if now_nt in['A','T','C','G']:new_s_list.append(c_nt[now_nt])
        else:new_s_list.append(now_nt)
    return ''.join(new_s_list)
    
def Get_Contigs(file_name):
    my_dict=dict()
    f=open(file_name)
    for i in f:
        if '>' in i:h=i.replace('>','').replace('\n','');my_dict[h]='';continue
        my_dict[h]+=(i.replace('\n','').upper())
    f.close()
    return my_dict

#def To_Connect(file_name,Sides,Bridges,target_bridge):
def To_Connect(file_name,Sides,target_bridge):
    bridges_info=[]
    fw_a=open('aliases_'+now_count+'.txt','w')
    fw_contig=open('Connected_Result_'+str(int(now_count)+1)+'.fa','w')
    f=open(file_name)
    #if clr is bridge put it to bridges_info_clr
    #if assembler's ctg is bridge put it to bridges_info_assembler
    for i in f:
        bridges_info.append(i.replace('\n',''))
    f.close()
    
        
    # Rule, according to bridges_into to column 4, 5 to remove sides
    # and then side1 + bridge + side2 => new_contigs
#Velvet_30_len:155	Velvet_156_211205_splited_1_len:204782	1	104	204679	204782	104	4e-50	104
#Velvet_30_len:155	Velvet_156_211205_splited_2_len:81	111	155	1	45	45	3e-17	45
    count=1
    for i in range(0,len(bridges_info),2):
        info1=bridges_info[i].split()
        info2=bridges_info[i+1].split()
        #1 side1 = side2 => skip, and remove this bridge
        if info1[1]==info2[1]:
            print "Remove clr: %s (to connect same sides %s %s)"%(info1[0],info1[1],info2[1])
            Sides.pop(info1[0]) 
            continue
        
        try:
            bridge=Sides[info1[0]]
            bridge_len=int(info1[0].split(":")[1])
            #process this condition => 10 ambiguous => clr123_len:9797   abyssxxx 2 3877
            #                                          clr123_len:9797   edenaxxx 4005 9797
            len_list=[]
            bridge1_s=int(info1[2]);bridge1_e=int(info1[3]);bridge2_s=int(info2[2]);bridge2_e=int(info2[3])

            if bridge1_e>bridge2_s:
                bridge=bridge1_e-bridge2_s
            else:
                bridge=bridge[bridge1_e-1:bridge2_s]
            
            side1=list(Sides[info1[1]])
            side2=list(Sides[info2[1]])
        except:
            if (not Sides.get(info1[1])) and (not Sides.get(info2[1])):
                #this bridge is depth of used bridge, so to connect same two side.
                #remove it
                print "Remove clr: %s (to connect same two different sides which have been connected by other long clr)"%info1[0]
                Sides.pop(info1[0])            
            #if only one side is used, keep the bridge to next round
            continue
        print '%s to connect %s and %s'%(info1[0],info1[1],info2[1])
        side1_s_int=int(info1[4]);side1_e_int=int(info1[5])
        side2_s_int=int(info2[4]);side2_e_int=int(info2[5])

        #use side to merge bridge
        if type(bridge)==type(1):#if bridge is int (means side1 and side2 have overlap), use longer to merge shorter.
            if len(side1)>len(side2):#side2 at tail=> side1 at bridge's left, side2 at bridge's right
                if side2_s_int<side2_e_int:
                    side2[:bridge]=[]
                if side2_s_int>side2_e_int:
                    side2[-bridge:]=[]
                    side2=complement(side2)
                if side1_s_int>side1_e_int:
                    side1=complement(side1)
            else:#side2 is longer
                if side1_s_int<side1_e_int:#side1 at head=> side1 at bridge's left, side2 at bridge's right
                    side1[-bridge:]=[]
                if side1_s_int>side1_e_int:
                    side1[:bridge]=[]
                    side1=complement(side1)
                if side2_s_int>side2_e_int:
                    side2=complement(side2)
            side1=''.join(side1);side2=''.join(side2)
            connected_contig=side1+side2
        else:
            if side1_s_int>side1_e_int:
                side1=complement(side1)
            if side2_s_int>side2_e_int:
                side2=complement(side2)
            side1=''.join(side1);side2=''.join(side2)
            connected_contig=side1+bridge+side2

        #this condition: side and bridge come from the same file, so remeber to pop side and bridge.
        #pop side
        Sides.pop(info1[1]);Sides.pop(info2[1])
        #pop bridge
        Sides.pop(info1[0])
        #print 'clr:%s to connect %s %s'%(info1[0],info1[1],info2[1])
        fw_a.write('Connected_Contig_clr_'+now_count+'_'+str(count)+'\tfrom:\t'+info1[1]+'\t'+info1[0]+'\t'+info2[1]+'\n')
        fw_contig.write('>Connected_Contig_clr_'+now_count+'_'+str(count)+'_len:'+str(len(connected_contig))+'\n')
        fw_contig.write(connected_contig+'\n')
        count+=1

    #no connect info, remove clr
    if not bridges_info:
        fw_remove=open('Unused_explained_clr.txt','a')
        for k in Sides.keys():
            if k[:3]==target_bridge:
                print 'remove %s'%k
                Sides.pop(k)
                fw_remove.write(k+'\n')
        fw_remove.close()
        
    for k in Sides.keys():
        fw_contig.write('>'+k+'\n')
        fw_contig.write(Sides[k]+'\n')
    fw_a.close();fw_contig.close()
    return (Sides)
    

def To_Replace(file_name,Sides,Bridges):
    f=open(file_name)
    count=1
    for i in f:
        tmp=i.split()
        b_name=tmp[0]
        s_name=tmp[1]
        Sides.pop(s_name)
        new_b_name='Replaced_'+now_count+'_'+str(count)+'_'+b_name
        Sides[new_b_name]=Bridges[b_name]
        count+=1
    f.close()
    return (Sides,Bridges)


#--------------Main------------------
#only use clr as bridge
target_bridge="clr"

Sides=Get_Contigs(contig_file)
(Sides)=To_Connect(bridge_file,Sides,target_bridge)






