#! /usr/bin/python
import sys
import os,commands,shutil,time,re
if len(sys.argv)!=2:print 'Please give a file!'
myfile=sys.argv[1]
f=open(myfile)
nucmer='nucmer'
makeblastdb='makeblastdb'
blastn='blastn'
bwtbuilder='2bwt-builder'
soap='soap'
my_result_path='Step3'
outfile="my_Patching_Result.fa"
substep4_dir="easy_bridging_A"
depth='0'
clrdepth='15'
switchsplitting='on'
switch1='on'
switch2='off'
switch3='on'
explained_ratio='0.95'
genome_size=''
read1='no'
read2='no'
min_i=''
max_i=''
start_time=time.strftime('%Y-%m-%d,%H:%M',time.localtime(time.time()))
print start_time

for i in f:
    if i[:1]=='#':continue
    if 'in_ref=' in i:
        in_ref=i.split('=')[1].replace('\n','')
    if 'in_clr=' in i:
        in_clr=i.split('=')[1].replace('\n','')
    if 'read1=' in i:
        read1=i.split('=')[1].replace('\n','')
    if 'read2=' in i:
        read2=i.split('=')[1].replace('\n','')
    if 'min_i=' in i:
        min_i=i.split('=')[1].replace('\n','')
    if 'max_i=' in i:
        max_i=i.split('=')[1].replace('\n','')
    if 'genomesize' in i:
        genome_size=i.split('=')[1].replace('\n','')
    if 'nucmer=' in i:
        nucmer=i.split('=')[1].replace('\n','')
    if '2bwt-builder=' in i:
        bwtbuilder=i.split('=')[1].replace('\n','')
    if 'soap=' in i:
        soap=i.split('=')[1].replace('\n','')
    if 'makeblastdb=' in i:
        makeblastdb=i.split('=')[1].replace('\n','')
    if 'blastn=' in i:
        blastn=i.split('=')[1].replace('\n','')
    if 'explained_ratio=' in i:
        explained_ratio=i.split('=')[1].replace('\n','')
        try:
            if float(explained_ratio)<0.95:explained_ratio='0.95'
        except:
            explained_ratio='0.95'
    if 'Split_depth=' in i:
        depth=i.split('=')[1].replace('\n','')
        try:
            if int(depth)>5:depth='5'
        except:
            depth='0'
    if 'Clr_depth=' in i:
        clrdepth=i.split('=')[1].replace('\n','')
        try:
            if int(clrdepth)>30 or int(clrdepth)<5:clrdepth='15'
        except:
            clrdepth='15'
    #if 'Output=' in i :
    #    my_result_path=i.split('=')[1].replace('\n','')
    if 'switch1off' in i:
        switch1='off'
    if 'switch2off' in i:
        switch2='off'
    if 'switch3off' in i:
        switch3='off'
    if 'switchSplittingoff' in i:
        switchsplitting='off'
#    if 'CISA=' in i:
#        CISA_S=i.split('=')[1].replace('\n','')+'/src'
CISA_S='bin'
current_p=os.getcwd()

if switch1=='on': 
    sys.path.append(CISA_S+'/Filling')
    from Controllor_R1 import R1
    if os.path.exists('Step1'):
        shutil.rmtree('Step1')
    os.makedirs('Step1')

    os.chdir('Step1')
    my_work=R1()
    my_work.Start(in_ref,in_clr,nucmer,CISA_S,read1,read2,min_i,max_i,depth,bwtbuilder,soap)
    os.chdir('../')

    if os.path.exists('Step1/Split_Ref.fa'):
        size_filled=os.path.getsize('Step1/Filled_my_ref.fa')
        size_split=os.path.getsize('Step1/Split_Ref.fa')
        if float(size_split)/float(size_filled)<0.8:
            while True:
                print 'The modified assembly was split into pieces (<80% of the original assembly), suggesting not to split the assembly with NGS data. Do you want to continue? (y/n, default: n)'
                choice = raw_input().lower()
                if choice == 'y' or choice == 'yes':
                    break
                if choice == 'n' or choice == 'no' or choice=='':
                    print choice
                    exit(0)

my_clr_file='Step1/my_CLR.fa'
if switch3=='on':
    if genome_size:#if genomesize is set, run gatekeeper to keep 15X clr
        print 'Keep long clr.'
        comm="python %s/bin/gatekeeper.py %s %s %s"%(current_p,'Step1/my_CLR.fa',genome_size,clrdepth)
        print comm
        (s,o)=commands.getstatusoutput(comm)
        my_clr_file='Step1/my_CLR.fa.Long.fa'
        
    if read1!='no' or read2!='no':
        command="cat %s %s > %s"%('Step1/Split_Ref.fa',my_clr_file,'Ctg_Clr.fa')#for Merge
        (s,o)=commands.getstatusoutput(command)
    else :
        command="cat %s %s > %s"%('Step1/Filled_my_ref.fa',my_clr_file,'Ctg_Clr.fa')#for Merge
        (s,o)=commands.getstatusoutput(command)        
    
    sys.path.append(CISA_S+'/Merge')
    from Controllor_R2_1 import R2_1
    if os.path.exists('Step2'):
        shutil.rmtree('Step2')
    os.makedirs('Step2')
    my_work=R2_1()
    my_work.Start('Ctg_Clr.fa',nucmer,CISA_S,current_p,explained_ratio)



def re_seq_name(input_ctg):
    f=open(input_ctg);fw=open('my_contig','w')
    my_dict=dict()
    count=1
    for i in f:
        if '>' in i:tmp_header=count;my_dict[tmp_header]='';count+=1;continue
        my_dict[tmp_header]+=(i.replace('\n',''))
    tmp_list=my_dict.keys()
    for key in sorted(tmp_list):
        seq=my_dict[key]
        fw.write('>Sequence_'+str(key)+'_len:'+str(len(seq))+'\n')
        fw.write(seq+'\n')
    f.close();fw.close()

def get_clr_only_to_connect_two_side(my_blast_file):
    keep_clr=dict()
    remove_this_ctg=[]
    ambigious=10
    at_left=[];at_right=[]
    f=open(my_blast_file)
    for i in f:
        if '# BLAST' in i:
            if len(at_left)==1 and len(at_right)==1:
                keep_clr[tmp[0]]=[]
                keep_clr[tmp[0]].append(at_left[0]);keep_clr[tmp[0]].append(at_right[0])
            at_left=[];at_right=[]
        if i[:1]=='#':continue
        tmp=i.split()
        if tmp[0]==tmp[1]:continue
        #Get ctg explained info
        if tmp[0][:3]!='clr':
            my_len=int(tmp[0].split(':')[1])
            my_start=int(tmp[2]);my_end=int(tmp[3])
            my_range=abs(my_end-my_start)+1
            if float(my_range)/float(my_len)>=0.95:
                remove_this_ctg.append(tmp[0])
        
        #Get clr as bridge info
        if tmp[0][:3]=='clr' and tmp[1][:3]!='clr':
            clr_len=int(tmp[0].split(':')[1])
            seq_len=int(tmp[1].split(':')[1])
            clr_s=int(tmp[2]);clr_e=int(tmp[3])
            seq_s=int(tmp[4]);seq_e=int(tmp[5])
            if clr_s<=ambigious or (clr_s<=clr_len and clr_s>=(clr_len-ambigious)):#clr left
                if (seq_s<=ambigious or (seq_s<=seq_len and seq_s>=(seq_len-ambigious))) or (seq_e<=ambigious or (seq_e<=seq_len and seq_e>=(seq_len-ambigious))):
                    at_left.append(i);continue
            if clr_e<=ambigious or (clr_e<=clr_len and clr_e>=(clr_len-ambigious)):#clr right
                if (seq_s<=ambigious or (seq_s<=seq_len and seq_s>=(seq_len-ambigious))) or (seq_e<=ambigious or (seq_e<=seq_len and seq_e>=(seq_len-ambigious))):
                    at_right.append(i);continue            
            
    f.close()
    return (keep_clr,remove_this_ctg)

#-----------Main--------------
def Get_Connected_Result_one(raw_file,target_file):
    d=dict()
    f=open(raw_file)
    while True:
        h=f.readline()
        if not h:break
        seq=f.readline()
        h=h.replace('>','')
        d[h]=seq
    f.close()
    fw=open(target_file,'w')
    for k in d.keys():
        fw.write('>'+k)
        fw.write(d[k])
    fw.close()
    
def only_one_head_one_tail_bridge(contig,outdir):
    keep_clr_round=1
    if os.path.exists(outdir):
        (s,o)=commands.getstatusoutput("rm -rf "+outdir)
        
    os.mkdir(outdir)
    (s,o)=commands.getstatusoutput('cp %s %s'%(contig,outdir))
    os.chdir(outdir)
    #(s,o)=commands.getstatusoutput('mv %s Connected_Result_1.fa'%contig.split('/')[-1])
    Get_Connected_Result_one(contig.split('/')[-1],'Connected_Result_1.fa')
    
    while True:
        now_keep_clr_path='keep_clr_%d.txt'%keep_clr_round
        now_connected_path='Connected_Result_%d.fa'%keep_clr_round
        now_blast='My_result_%d.txt'%keep_clr_round
        
        cmd="%s -in %s -dbtype nucl -parse_seqids -out Side_DB"%(makeblastdb,now_connected_path)
        (s,o)=commands.getstatusoutput(cmd)
        print cmd
        cmd="%s -query %s -db Side_DB -out %s -word_size 28 -reward 1 -penalty -2 -outfmt '7 qseqid sseqid qstart qend sstart send length evalue score'"%(blastn,now_connected_path,now_blast)
        (s,o)=commands.getstatusoutput(cmd)
        print cmd
        (s,o)=commands.getstatusoutput("rm Side_DB*")
        (keep_clr,remove_this_ctg)=get_clr_only_to_connect_two_side(now_blast)
        
        fw=open(now_keep_clr_path,'w')
        keep_bridge_info=[]
        for key in keep_clr.keys():
            for data in keep_clr[key]:
                keep_bridge_info.append(data)
        keep_bridge_info=sorted(keep_bridge_info,key=lambda x:int(x.split()[0].split(':')[1]),reverse=True)
        for keep_bridge_data in keep_bridge_info:
            fw.write(keep_bridge_data)        
        fw.close()

    # do connect by keep_bridge_info ( clr from long to short)
    # remove sides and bridge from Connected_Result.fa, put new seq into Connected_Result.fa
    # if sides with long clr has beed used, remove this short clr from Connected_Result.fa

        # if now_keep_clr_path is empty, the script will remove all clr
        comm="python %s/bin/Connection_with_kept_Bridge.py %s %s %d"%(current_p,now_connected_path,now_keep_clr_path,keep_clr_round)
        print comm
        (s,o)=commands.getstatusoutput(comm)
        print o
        #return 'Connected_Result_%d.fa'%keep_clr_round+1

        keep_clr_round+=1
        if os.path.getsize(now_keep_clr_path)==0:
            now_connected_path='Connected_Result_%d.fa'%keep_clr_round
            break

    if remove_this_ctg:
        print 'To remove explained ctg.'
        f=open(now_connected_path)
        tmp_data=f.readlines()
        f.close()
        fw=open(now_connected_path,'w')
        for i in range(0,len(tmp_data),2):
            h=tmp_data[i].replace('>','').replace('\n','')
            s=tmp_data[i+1]
            if h in remove_this_ctg:
                print 'Remove %s, this ctg have beed explained.'%h
                continue
            fw.write('>'+h+'\n');fw.write(s)
        fw.close()

    comm="cp %s %s"%(now_connected_path,outfile)
    (s,o)=commands.getstatusoutput(comm)

    comm="python %s/bin/N50.py %s"%(current_p,outfile)
    print comm
    (s,o)=commands.getstatusoutput(comm)
    print o
    
    os.chdir('../')
    #Connected_Result_withclr.fa from Connection_with_kept_Bridge.py
    return now_connected_path

def To_Connect_Extend(explained,cisa12,contig,my_result_path,outfile,Do_Get_Back):
    #blast result for repeat file
    my_blast_file=''
    #get explained info
    explained_dict=dict()
    f=open(explained)
    while True:
        refid=f.readline().replace('\n','').replace('RefID: ','>')
        if not refid:break
        explained_data=f.readline().replace('\n','')
        explained_dict[refid]=explained_data.split()
    f.close()
    #get CISA12 result
    cisa12_dict=dict()
    f=open(cisa12)
    while True:
        h=f.readline().replace('\n','')
        if not h:break
        s=f.readline().replace('\n','')
        cisa12_dict[h]=s
    f.close()
    
    current_p=os.getcwd()
    #-----------------------------
    #Move the contig to strict_bridging_* and rename to my_contig
    
    if os.path.exists(my_result_path):
        (s,o)=commands.getstatusoutput("rm -rf "+my_result_path)
        (s,o)=commands.getstatusoutput("mkdir "+my_result_path)
        #print 'The folder %s is existent.';exit(0)
    else:
        (s,o)=commands.getstatusoutput("mkdir "+my_result_path)
    os.chdir(my_result_path)
    
    count=1
    my_next_lib=[]
    
    while True:
        if contig=='no':print 'Need a contig file!';exit(0)
        now_c='strict_bridging_'+str(count)
        print now_c
        (s,o)=commands.getstatusoutput("mkdir "+now_c)
        os.chdir(now_c)
        #now_processed_contig='Contig_%s.fa'%str(count)
    #------------------------------
    
        print "Connection and Extension."
        (s,o)=commands.getstatusoutput("mkdir CE")
        os.chdir('CE')
    #Blast
        cmd="%s -in %s -dbtype nucl -parse_seqids -out Side_DB"%(makeblastdb,contig)
        (s,o)=commands.getstatusoutput(cmd)
        print cmd
        cmd="%s -query %s -db Side_DB -out My_result.txt -word_size 28 -reward 1 -penalty -2 -outfmt '7 qseqid sseqid qstart qend sstart send length evalue score'"%(blastn,contig)
        (s,o)=commands.getstatusoutput(cmd)
        print cmd
        (s,o)=commands.getstatusoutput("rm Side_DB*")
    #Bridges and Extensions
        comm="python %s/bin/Get_Bridges.py"%(current_p)
        (s,o)=commands.getstatusoutput(comm)
        print o
        comm="python %s/bin/Connection_withBridgeExtension.py %s %d"%(current_p,contig,count)
        (s,o)=commands.getstatusoutput(comm)
        print o
        print "Done! Connection and Extension."
        (s,o)=commands.getstatusoutput("cp 2_Contigs_B.fa ../")
        os.chdir('../')
     
    #-----------------------------
        
    #ReSet Path
        old_contig_size=os.path.getsize(contig)
        contig=current_p+'/'+my_result_path+'/'+now_c+'/2_Contigs_B.fa'
        #this step is to avoid strange character################
        f_tmp=open(contig)
        f_list=f_tmp.readlines();
        f_tmp.close()

        fw_tmp=open(contig,'w')
        for i in f_list:
            if '>' in i:
                fw_tmp.write(i);continue
            i=re.sub('\W','',i)
            fw_tmp.write(i+'\n')
        fw_tmp.close()        
        ################################
        Extension_file=current_p+'/'+my_result_path+'/'+now_c+'/CE/1_Extensions.txt'
        Bridges_file=current_p+'/'+my_result_path+'/'+now_c+'/CE/1_Bridges.txt'
        my_blast_file=current_p+'/'+my_result_path+'/'+now_c+'/CE/My_result.txt'
        size_e=os.path.getsize(Extension_file);size_b=os.path.getsize(Bridges_file)
        new_contig_size=os.path.getsize(contig)
        os.chdir('../')
    
    #rm old strict_bridging_(X-1).
        #(s,o)=commands.getstatusoutput("rm -rf %s"%('strict_bridging_'+str(count-1)))

        (keep_clr,remove_this_ctg)=get_clr_only_to_connect_two_side(my_blast_file)
    
    #if time to exit?
        back_clr=[]
        keep_bridge_info=[]
        print 'Contig Size => old:%d new:%d'%(old_contig_size,new_contig_size)
        #if size==0 or (old_contig_size==new_contig_size): #or ( 1 >= (float(old_contig_size)/float(new_contig_size)) >= 0.98):
        #if size_e==0 or size_b==0 or old_contig_size==new_contig_size:
        if old_contig_size==new_contig_size:
            (s,o)=commands.getstatusoutput("cp %s ./"%(contig))
            f=open(contig);fw=open('Connected_Result_1.fa','w');genome_tmp=0;
            while True:
                h=f.readline().replace('\n','')
                if not h:break
                s=f.readline().replace('\n','')
                if Do_Get_Back:
                    if h[:4]==">clr":
                        #if this clr_bridge only have one pair side's head and tile. keep it
                        tmp_clr_header=h.replace('>','').replace('\n','')
                        if keep_clr.get(tmp_clr_header):
                            for tmp_data in keep_clr[tmp_clr_header]:
                                keep_bridge_info.append(tmp_data)                             
                            
                            fw.write(h+'\n');fw.write(s+'\n');genome_tmp+=len(s.replace('\n',''))
                            print 'This clr %s can be a bridge, keep it.'%h
                            continue
                        
                        # if this clr at CISA2_1's explained's RefID, get back it's explained ctg
                        if explained_dict.get(h):
                            back_clr.append(h)
                            print 'Remove:%s'%h
                            for raw_ctg in explained_dict[h]:
                                print "Get Back:%s"%raw_ctg
                                seq_tmp=cisa12_dict['>'+raw_ctg]
                                fw.write('>'+raw_ctg+'\n');fw.write(seq_tmp+'\n');
                                genome_tmp+=len(seq_tmp)
                        continue
                fw.write(h+'\n');fw.write(s+'\n');genome_tmp+=len(s.replace('\n',''))
            f.close();fw.close();
            #print "Genome Size:%d"%genome_tmp
            #(s,o)=commands.getstatusoutput("mv my_split_contig.fa Result.fa")
            break
    #------------------------------
        count+=1

    #fw_keep=open('keep_clr_1.txt','w')
    #keep_bridge_info=sorted(keep_bridge_info,key=lambda x:int(x.split()[0].split(':')[1]),reverse=True)
    #for keep_bridge_data in keep_bridge_info:
    #    fw_keep.write(keep_bridge_data)
    #fw_keep.close()
    
    # to Connect use bridge which only connect two side(head and tail)
    #use Connected_Result_1.fa to iteratly connect

    now_connected_path=only_one_head_one_tail_bridge('Connected_Result_1.fa',substep4_dir)

    (s,o)=commands.getstatusoutput("cp %s/%s ./"%(substep4_dir,now_connected_path))
    For_Overlap_Input=now_connected_path
    print 'For_Overlap_input: %s'%For_Overlap_Input
    #Get repeat region by blast_result
    cmd="%s -in %s -dbtype nucl -parse_seqids -out Side_DB"%(makeblastdb,For_Overlap_Input)
    (s,o)=commands.getstatusoutput(cmd)
    print cmd
    cmd="%s -query %s -db Side_DB -out My_result.txt -word_size 28 -reward 1 -penalty -2 -outfmt '7 qseqid sseqid qstart qend sstart send length evalue score'"%(blastn,For_Overlap_Input)
    (s,o)=commands.getstatusoutput(cmd)
    print cmd
    (s,o)=commands.getstatusoutput("rm Side_DB*")
    
    comm="python %s/bin/Get_Repeat.py %s"%(current_p,'My_result.txt')
    (s,o)=commands.getstatusoutput(comm)
    print o
    repeat_region=o.split(':')[1]
    fw_rr=open('RR.txt','w')
    fw_rr.write(repeat_region+'\n')
    fw_rr.close()
    #Overlap
    comm="cp %s Contigs_1.fa"%For_Overlap_Input
    (s,o)=commands.getstatusoutput(comm)
    
    sys.path.append('%s/bin/Overlap'%current_p)
    if not os.path.exists('Overlap'):os.makedirs('Overlap')
    from Controllor_R4 import R4
    my_work=R4()
    my_work.Start(repeat_region,'1',"%s/bin"%current_p,("%s/%s")%(current_p,my_result_path),makeblastdb,blastn)
    #parameter1 repeat_region
    #parameter2 start from contig_x.fa
    #p3 where are code
    #p4 where to put produced data
    #p5 p6 where are blast toolkit
    f=open('info2')
    for data in f:
        if 'Round4_result=' in data:R4_end=data.split('=')[1].replace('\n','')
    f.close()
    if R4_end:final=R4_end
    os.rename('Contigs_'+final+'.fa',outfile)
    #final=int(final)
    #for i in range(1,final):
    #    if os.path.exists('Contigs_'+str(i)+'.fa'):os.remove('Contigs_'+str(i)+'.fa')
    
    os.chdir('../')#leave NHRI_Correction_Result
    return (back_clr,repeat_region)

def Get_CLR2_Back(Last_Round_Unused_Clr,contig,all_clr,back_clr,repeat_region):
    #blast result for repeat file
    my_blast_file=''
    #get explained info
    Unused_Clr=set()
    f=open(Last_Round_Unused_Clr)
    for i in f:
        if 'clr' in i:
            i=i.replace('\n','')
            Unused_Clr.add(i)
    f.close()

    clr_dict=dict()
    f=open(all_clr)
    while True:
        h=f.readline().replace('\n','').replace('>','')
        if not h:break
        s=f.readline().replace('\n','')
        clr_dict[h]=s
    f.close()
    
    fw=open(contig.replace('.fa','_withCLR.fa'),'w')
    f=open(contig);
    for i in f:fw.write(i)
    f.close()
    
    repeat_region=int(repeat_region)
    get_back_clr=[]
    for i in Unused_Clr:
        length=int(i.split(':')[1].replace('\n',''))
        if length<=repeat_region:continue
        try:
            seq=clr_dict[i]
            print "Get Back:%s"%i
            fw.write('>'+i+'\n')
            fw.write(seq+'\n')
        except:
            continue
    fw.close()
#NHRIGapFiller
print 'GapFilling...'
contig=current_p+'/Step2/Merge_Contigs.fa'
explained=current_p+'/Step2/explained.txt'
cisa12=current_p+'/Ctg_Clr.fa'
(back_clr,repeat_region)=To_Connect_Extend(explained,cisa12,contig,my_result_path,outfile,True)#True means to get Back(ctg)


#if a clr that doesn't attend connect or extend, remove it, and get back short and explained clr by this big clr
#(s,o)=commands.getstatusoutput("cat "+current_p+"/CLR2/*/CLR2/explained.txt >" +current_p+"/CLR2/All_Explained.txt")



#remove clrs in back_clr , if clr is used to connect at Clr_Bridge_ite                                   
Get_CLR2_Back(current_p+"/"+my_result_path+"/"+substep4_dir+"/Unused_explained_clr.txt",my_result_path+"/"+outfile,current_p+"/"+my_clr_file,back_clr,repeat_region)
print 'GapFilling with clr, Round1.'




contig=current_p+"/"+my_result_path+"/"+outfile.replace('.fa','_withCLR.fa')
outdir="easy_bridging_B"
os.chdir(my_result_path)
only_one_head_one_tail_bridge(contig,outdir)
(s,o)=commands.getstatusoutput("rm *.fa")
(s,o)=commands.getstatusoutput("rm info2")
(s,o)=commands.getstatusoutput("rm My_result.txt")
os.chdir('../')
(s,o)=commands.getstatusoutput("cp %s/%s/%s ./patched1.ctg.fa"%(my_result_path,outdir,outfile))

#rename
ctg_list=[]
f=open('patched1.ctg.fa')
for i in f:
    if '>' in i:continue
    ctg_list.append(i.replace('\n',''))
f.close()

ctg_list=sorted(ctg_list,key=lambda seq:len(seq),reverse=True)

count=1
fw=open('patched.ctg.fa','w')
for seq in ctg_list:
    fw.write('>Contig_%d_len:%d\n'%(count,len(seq)))
    fw.write('%s\n'%seq)
    count+=1
fw.close()

(s,o)=commands.getstatusoutput("rm info")
(s,o)=commands.getstatusoutput("rm patched1.ctg.fa")
#patched.ctg.fa

print start_time
print time.strftime('%Y-%m-%d,%H:%M',time.localtime(time.time()))










